
electronique_chenillard_006c_16f628_Init:
;electronique_chenillard_006c_16f628.mpas,37 :: 		begin
;electronique_chenillard_006c_16f628.mpas,39 :: 		CMCON := 7;
	MOVLW      7
	MOVWF      CMCON+0
;electronique_chenillard_006c_16f628.mpas,41 :: 		Option_REG.NOT_RBPU := 0;  // enable pullups
	BCF        OPTION_REG+0, 7
;electronique_chenillard_006c_16f628.mpas,44 :: 		OPTION_REG.T0CS := 0;  // bit 5 TMR0 Clock Source Select bit:0=Internal Clock (CLKO) / 1=Transition on T0CKI pin
	BCF        OPTION_REG+0, 5
;electronique_chenillard_006c_16f628.mpas,45 :: 		OPTION_REG.T0SE := 0;  // bit 4 TMR0 Source Edge Select bit: 0=low/high / 1=high/low
	BCF        OPTION_REG+0, 4
;electronique_chenillard_006c_16f628.mpas,46 :: 		OPTION_REG.PSA  := 1;  // bit 3 Prescaler Assignment bit: 0=Prescaler is assigned to the Timer0
	BSF        OPTION_REG+0, 3
;electronique_chenillard_006c_16f628.mpas,47 :: 		OPTION_REG.PS2  := 0;  // bits 2-0  PS2:PS0: Prescaler Rate Select bits
	BCF        OPTION_REG+0, 2
;electronique_chenillard_006c_16f628.mpas,48 :: 		OPTION_REG.PS1  := 0;
	BCF        OPTION_REG+0, 1
;electronique_chenillard_006c_16f628.mpas,49 :: 		OPTION_REG.PS0  := 0;
	BCF        OPTION_REG+0, 0
;electronique_chenillard_006c_16f628.mpas,50 :: 		TMR0 := 0;             // preset for timer register
	CLRF       TMR0+0
;electronique_chenillard_006c_16f628.mpas,52 :: 		INTCON.GIE  := 1;
	BSF        INTCON+0, 7
;electronique_chenillard_006c_16f628.mpas,53 :: 		INTCON.T0IE := 1;
	BSF        INTCON+0, 5
;electronique_chenillard_006c_16f628.mpas,54 :: 		INTCON.INTE := 0;  // disable RB0 int
	BCF        INTCON+0, 4
;electronique_chenillard_006c_16f628.mpas,55 :: 		INTCON.RBIE := 1;  // enable RB4..RB7 int
	BSF        INTCON+0, 3
;electronique_chenillard_006c_16f628.mpas,57 :: 		TRISA       := %11110000;  // RA0..RA3 as output, others as input
	MOVLW      240
	MOVWF      TRISA+0
;electronique_chenillard_006c_16f628.mpas,58 :: 		TRISB       := %11000000;  // RB0..RB5 as output, others as input
	MOVLW      192
	MOVWF      TRISB+0
;electronique_chenillard_006c_16f628.mpas,59 :: 		PORTA       := 0;  // clear porta
	CLRF       PORTA+0
;electronique_chenillard_006c_16f628.mpas,60 :: 		PORTB       := 0;  // clear portb
	CLRF       PORTB+0
;electronique_chenillard_006c_16f628.mpas,61 :: 		iTimerCount := 0;
	CLRF       _iTimerCount+0
	CLRF       _iTimerCount+1
;electronique_chenillard_006c_16f628.mpas,62 :: 		ProgToUse   := $0000;
	CLRF       _ProgToUse+0
	CLRF       _ProgToUse+1
;electronique_chenillard_006c_16f628.mpas,63 :: 		ProgIdx     := 0;
	CLRF       _ProgIdx+0
;electronique_chenillard_006c_16f628.mpas,64 :: 		iSpeed      := 127;
	MOVLW      127
	MOVWF      _iSpeed+0
;electronique_chenillard_006c_16f628.mpas,65 :: 		bProgReadyToChange := false;
	CLRF       _bProgReadyToChange+0
;electronique_chenillard_006c_16f628.mpas,66 :: 		bPushButtonOld := 0;
	CLRF       _bPushButtonOld+0
;electronique_chenillard_006c_16f628.mpas,67 :: 		end;
	RETURN
; end of electronique_chenillard_006c_16f628_Init

electronique_chenillard_006c_16f628_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0
;electronique_chenillard_006c_16f628.mpas,70 :: 		begin
;electronique_chenillard_006c_16f628.mpas,71 :: 		if INTCON.T0IF then
	BTFSS      INTCON+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt3
;electronique_chenillard_006c_16f628.mpas,73 :: 		inc(iTimerCount);
	INCF       _iTimerCount+0, 1
	BTFSC      STATUS+0, 2
	INCF       _iTimerCount+1, 1
;electronique_chenillard_006c_16f628.mpas,74 :: 		TMR0   :=  0;
	CLRF       TMR0+0
;electronique_chenillard_006c_16f628.mpas,75 :: 		INTCON.T0IF := 0;       // reset T0 flag
	BCF        INTCON+0, 2
;electronique_chenillard_006c_16f628.mpas,76 :: 		end;
L_electronique_chenillard_006c_16f628_Interrupt3:
;electronique_chenillard_006c_16f628.mpas,77 :: 		if INTCON.RBIF then
	BTFSS      INTCON+0, 0
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt6
;electronique_chenillard_006c_16f628.mpas,79 :: 		if PORTB.6 = 0 then       // speed down
	BTFSC      PORTB+0, 6
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt9
;electronique_chenillard_006c_16f628.mpas,81 :: 		if iSpeed > 10 then
	MOVF       _iSpeed+0, 0
	SUBLW      10
	BTFSC      STATUS+0, 0
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt12
;electronique_chenillard_006c_16f628.mpas,82 :: 		iSpeed := iSpeed - 10
	MOVLW      10
	SUBWF      _iSpeed+0, 1
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt13
;electronique_chenillard_006c_16f628.mpas,83 :: 		else
L_electronique_chenillard_006c_16f628_Interrupt12:
;electronique_chenillard_006c_16f628.mpas,84 :: 		iSpeed := 1;
	MOVLW      1
	MOVWF      _iSpeed+0
L_electronique_chenillard_006c_16f628_Interrupt13:
;electronique_chenillard_006c_16f628.mpas,85 :: 		end
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt10
;electronique_chenillard_006c_16f628.mpas,86 :: 		else
L_electronique_chenillard_006c_16f628_Interrupt9:
;electronique_chenillard_006c_16f628.mpas,87 :: 		if PORTB.7 = 0 then       // speed up
	BTFSC      PORTB+0, 7
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt15
;electronique_chenillard_006c_16f628.mpas,89 :: 		if iSpeed < 245 then
	MOVLW      245
	SUBWF      _iSpeed+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt18
;electronique_chenillard_006c_16f628.mpas,90 :: 		iSpeed := iSpeed + 10
	MOVLW      10
	ADDWF      _iSpeed+0, 1
	GOTO       L_electronique_chenillard_006c_16f628_Interrupt19
;electronique_chenillard_006c_16f628.mpas,91 :: 		else
L_electronique_chenillard_006c_16f628_Interrupt18:
;electronique_chenillard_006c_16f628.mpas,92 :: 		iSpeed := 255;
	MOVLW      255
	MOVWF      _iSpeed+0
L_electronique_chenillard_006c_16f628_Interrupt19:
;electronique_chenillard_006c_16f628.mpas,93 :: 		end;
L_electronique_chenillard_006c_16f628_Interrupt15:
L_electronique_chenillard_006c_16f628_Interrupt10:
;electronique_chenillard_006c_16f628.mpas,94 :: 		INTCON.RBIF := 0;         //reset RB4..RB7 int flag
	BCF        INTCON+0, 0
;electronique_chenillard_006c_16f628.mpas,95 :: 		end;
L_electronique_chenillard_006c_16f628_Interrupt6:
;electronique_chenillard_006c_16f628.mpas,97 :: 		end;
L_electronique_chenillard_006c_16f628_Interrupt77:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of electronique_chenillard_006c_16f628_Interrupt

electronique_chenillard_006c_16f628_GetFigure:
;electronique_chenillard_006c_16f628.mpas,100 :: 		begin
;electronique_chenillard_006c_16f628.mpas,102 :: 		0  : Result := %0000000000000000;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure24
	CLRF       R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure24:
;electronique_chenillard_006c_16f628.mpas,103 :: 		1  : Result := %0000000000000001;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure27
	MOVLW      1
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure27:
;electronique_chenillard_006c_16f628.mpas,104 :: 		2  : Result := %0000000000000011;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure30
	MOVLW      3
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure30:
;electronique_chenillard_006c_16f628.mpas,105 :: 		3  : Result := %0000000000000111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure33
	MOVLW      7
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure33:
;electronique_chenillard_006c_16f628.mpas,106 :: 		4  : Result := %0000000000001111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure36
	MOVLW      15
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure36:
;electronique_chenillard_006c_16f628.mpas,107 :: 		5  : Result := %0000000000011111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure39
	MOVLW      31
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure39:
;electronique_chenillard_006c_16f628.mpas,108 :: 		6  : Result := %0000000000111111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure42
	MOVLW      63
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure42:
;electronique_chenillard_006c_16f628.mpas,109 :: 		7  : Result := %0000000001111111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure45
	MOVLW      127
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure45:
;electronique_chenillard_006c_16f628.mpas,110 :: 		8  : Result := %0000000011111111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure48
	MOVLW      255
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure48:
;electronique_chenillard_006c_16f628.mpas,111 :: 		9  : Result := %0000000111111111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure51
	MOVLW      255
	MOVWF      R2+0
	MOVLW      1
	MOVWF      R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure51:
;electronique_chenillard_006c_16f628.mpas,112 :: 		10 : Result := %0000001111111111;
	MOVF       FARG_GetFigure_idx+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure54
	MOVLW      255
	MOVWF      R2+0
	MOVLW      3
	MOVWF      R2+1
	GOTO       L_electronique_chenillard_006c_16f628_GetFigure21
L_electronique_chenillard_006c_16f628_GetFigure54:
L_electronique_chenillard_006c_16f628_GetFigure21:
;electronique_chenillard_006c_16f628.mpas,114 :: 		end;
	MOVF       R2+0, 0
	MOVWF      R0+0
	MOVF       R2+1, 0
	MOVWF      R0+1
	RETURN
; end of electronique_chenillard_006c_16f628_GetFigure

_main:
;electronique_chenillard_006c_16f628.mpas,116 :: 		begin
;electronique_chenillard_006c_16f628.mpas,118 :: 		Init;
	CALL       electronique_chenillard_006c_16f628_Init+0
;electronique_chenillard_006c_16f628.mpas,119 :: 		while true do
L__main57:
;electronique_chenillard_006c_16f628.mpas,121 :: 		bModeAuto := (TestBit(PORTA, 6) = 1);
	CLRF       R1+0
	BTFSS      PORTA+0, 6
	GOTO       L__main61
	MOVLW      1
	MOVWF      R1+0
L__main61:
	MOVF       R1+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _bModeAuto+0
;electronique_chenillard_006c_16f628.mpas,124 :: 		if bModeAuto then
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main63
;electronique_chenillard_006c_16f628.mpas,126 :: 		bProgReadyToChange := (iTimerCount >= iSpeed);
	MOVLW      0
	SUBWF      _iTimerCount+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main78
	MOVF       _iSpeed+0, 0
	SUBWF      _iTimerCount+0, 0
L__main78:
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      _bProgReadyToChange+0
;electronique_chenillard_006c_16f628.mpas,127 :: 		end
	GOTO       L__main64
;electronique_chenillard_006c_16f628.mpas,128 :: 		else
L__main63:
;electronique_chenillard_006c_16f628.mpas,131 :: 		if (Button(PORTA, 5, 50, 1) = 255) and (bPushButtonOld = 0) then
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      5
	MOVWF      FARG_Button_pin+0
	MOVLW      50
	MOVWF      FARG_Button_time+0
	MOVLW      1
	MOVWF      FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       R0+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _bPushButtonOld+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main66
;electronique_chenillard_006c_16f628.mpas,133 :: 		bProgReadyToChange := true;
	MOVLW      255
	MOVWF      _bProgReadyToChange+0
;electronique_chenillard_006c_16f628.mpas,134 :: 		bPushButtonOld := 255;
	MOVLW      255
	MOVWF      _bPushButtonOld+0
;electronique_chenillard_006c_16f628.mpas,135 :: 		end;
L__main66:
;electronique_chenillard_006c_16f628.mpas,136 :: 		if ((PORTA.5 = 0) and (bPushButtonOld = 255)) then
	BTFSC      PORTA+0, 5
	GOTO       L__main79
	BSF        114, 0
	GOTO       L__main80
L__main79:
	BCF        114, 0
L__main80:
	MOVF       _bPushButtonOld+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	CLRF       R0+0
	BTFSC      114, 0
	INCF       R0+0, 1
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main69
;electronique_chenillard_006c_16f628.mpas,137 :: 		bPushButtonOld := 0;
	CLRF       _bPushButtonOld+0
L__main69:
;electronique_chenillard_006c_16f628.mpas,138 :: 		end;
L__main64:
;electronique_chenillard_006c_16f628.mpas,140 :: 		if bProgReadyToChange then
	MOVF       _bProgReadyToChange+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main72
;electronique_chenillard_006c_16f628.mpas,142 :: 		if ProgIdx < iProgCount then
	MOVLW      10
	SUBWF      _ProgIdx+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main75
;electronique_chenillard_006c_16f628.mpas,143 :: 		inc(ProgIdx) // go to next set of figures
	INCF       _ProgIdx+0, 1
	GOTO       L__main76
;electronique_chenillard_006c_16f628.mpas,144 :: 		else
L__main75:
;electronique_chenillard_006c_16f628.mpas,145 :: 		ProgIdx := 0;
	CLRF       _ProgIdx+0
L__main76:
;electronique_chenillard_006c_16f628.mpas,146 :: 		OutData := GetFigure(ProgIdx);
	MOVF       _ProgIdx+0, 0
	MOVWF      FARG_GetFigure_idx+0
	CALL       electronique_chenillard_006c_16f628_GetFigure+0
	MOVF       R0+0, 0
	MOVWF      _OutData+0
	MOVF       R0+1, 0
	MOVWF      _OutData+1
;electronique_chenillard_006c_16f628.mpas,147 :: 		PORTA.0 := OutData.0;
	BTFSC      _OutData+0, 0
	GOTO       L__main81
	BCF        PORTA+0, 0
	GOTO       L__main82
L__main81:
	BSF        PORTA+0, 0
L__main82:
;electronique_chenillard_006c_16f628.mpas,148 :: 		PORTA.1 := OutData.1;
	BTFSC      _OutData+0, 1
	GOTO       L__main83
	BCF        PORTA+0, 1
	GOTO       L__main84
L__main83:
	BSF        PORTA+0, 1
L__main84:
;electronique_chenillard_006c_16f628.mpas,149 :: 		PORTA.2 := OutData.2;
	BTFSC      _OutData+0, 2
	GOTO       L__main85
	BCF        PORTA+0, 2
	GOTO       L__main86
L__main85:
	BSF        PORTA+0, 2
L__main86:
;electronique_chenillard_006c_16f628.mpas,150 :: 		PORTA.3 := OutData.3;
	BTFSC      _OutData+0, 3
	GOTO       L__main87
	BCF        PORTA+0, 3
	GOTO       L__main88
L__main87:
	BSF        PORTA+0, 3
L__main88:
;electronique_chenillard_006c_16f628.mpas,151 :: 		PORTB.0 := OutData.4;
	BTFSC      _OutData+0, 4
	GOTO       L__main89
	BCF        PORTB+0, 0
	GOTO       L__main90
L__main89:
	BSF        PORTB+0, 0
L__main90:
;electronique_chenillard_006c_16f628.mpas,152 :: 		PORTB.1 := OutData.5;
	BTFSC      _OutData+0, 5
	GOTO       L__main91
	BCF        PORTB+0, 1
	GOTO       L__main92
L__main91:
	BSF        PORTB+0, 1
L__main92:
;electronique_chenillard_006c_16f628.mpas,153 :: 		PORTB.2 := OutData.6;
	BTFSC      _OutData+0, 6
	GOTO       L__main93
	BCF        PORTB+0, 2
	GOTO       L__main94
L__main93:
	BSF        PORTB+0, 2
L__main94:
;electronique_chenillard_006c_16f628.mpas,154 :: 		PORTB.3 := OutData.7;
	BTFSC      _OutData+0, 7
	GOTO       L__main95
	BCF        PORTB+0, 3
	GOTO       L__main96
L__main95:
	BSF        PORTB+0, 3
L__main96:
;electronique_chenillard_006c_16f628.mpas,155 :: 		PORTB.4 := OutData.8;
	BTFSC      _OutData+1, 0
	GOTO       L__main97
	BCF        PORTB+0, 4
	GOTO       L__main98
L__main97:
	BSF        PORTB+0, 4
L__main98:
;electronique_chenillard_006c_16f628.mpas,156 :: 		PORTB.5 := OutData.9;
	BTFSC      _OutData+1, 1
	GOTO       L__main99
	BCF        PORTB+0, 5
	GOTO       L__main100
L__main99:
	BSF        PORTB+0, 5
L__main100:
;electronique_chenillard_006c_16f628.mpas,157 :: 		iTimerCount := 0;
	CLRF       _iTimerCount+0
	CLRF       _iTimerCount+1
;electronique_chenillard_006c_16f628.mpas,158 :: 		bProgReadyToChange := false;
	CLRF       _bProgReadyToChange+0
;electronique_chenillard_006c_16f628.mpas,159 :: 		end;
L__main72:
;electronique_chenillard_006c_16f628.mpas,160 :: 		end;
	GOTO       L__main57
;electronique_chenillard_006c_16f628.mpas,161 :: 		end.
	GOTO       $+0
; end of _main
